<%
' Comersus 5.0x Sophisticated Cart 
' Developed by Rodrigo S. Alhadeff for Comersus Open Technologies
' United States 
' Open Source License can be found at License.txt
' http://www.comersus.com  
' Details: verifies if cart is empty in order to allow checkout and display first checkout screen
%>

<!--#include virtual="/comersus/includes/settings.asp"-->
<!--#include virtual="/comersus/includes/getSettingKey.asp"--> 
<!--#include virtual="/comersus/includes/databaseFunctions.asp"-->  
<!--#include virtual="/comersus/includes/languages.asp"--> 
<!--#include virtual="/comersus/includes/cartFunctions.asp"--> 
<!--#include virtual="/comersus/includes/currencyFormat.asp"--> 
<!--#include virtual="/comersus/includes/validateForm.asp" --> 
<!--#include virtual="/comersus/includes/sessionFunctions.asp"-->

<%
on error resume next

dim mySQL, connTemp, rsTemp, f, cont

' get settings 
pDefaultLanguage 	= getSettingKey("pDefaultLanguage")
pStoreFrontDemoMode 	= getSettingKey("pStoreFrontDemoMode")
pCurrencySign	 	= getSettingKey("pCurrencySign")
pDecimalSign	 	= getSettingKey("pDecimalSign")
pCompany	 	= getSettingKey("pCompany")
pCompanyLogo	 	= getSettingKey("pCompanyLogo")

pMinimumPurchase 	= getSettingKey("pMinimumPurchase")
pAllowNewCustomer	= getSettingKey("pAllowNewCustomer")
pForgotPassword		= getSettingKey("pForgotPassword")
pStoreClosed		= getSettingKey("pStoreClosed")
pAllowNewCustomer	= getSettingKey("pAllowNewCustomer")
pMoneyDontRound	 	= getSettingKey("pMoneyDontRound")
pSecureStoreGraph 	= getSettingKey("pSecureStoreGraph")

' if the store is closed it will not allow checkout
if pStoreClosed="-1" then
 response.redirect "comersus_message.asp?message="&Server.Urlencode(dictLanguage.Item(Session("language")&"_checkout_11"))
end if

pIdDbSession	 = checkSessionData()
pIdDbSessionCart = checkDbSessionCartOpen()

if countCartRows(pIdDbSessionCart)=0 then
  response.redirect "comersus_message.asp?message="&Server.Urlencode(dictLanguage.Item(Session("language")&"_checkout_1") )
end if

if Cdbl(calculateCartTotal(pIdDbSessionCart))<Cdbl(pMinimumPurchase) then  
  response.redirect "comersus_message.asp?message="&Server.Urlencode(dictLanguage.Item(Session("language")&"_checkout_10")& pCurrencySign &money(pMinimumPurchase))
end if

pIdCustomer     = getSessionVariable("idCustomer",0)

' check if user already logged in
if pIdCustomer<>0 then
   response.redirect "comersus_login.asp"
end if

%>
<!--#include file="header.asp"-->
<br><br><b><%=dictLanguage.Item(Session("language")&"_checkout_7")%></b>
<%if pAllowNewCustomer="-1" then%>
<p align="left"><%=dictLanguage.Item(Session("language")&"_checkout_2")%><a href="comersus_checkOutCustomerForm.asp"> <%=dictLanguage.Item(Session("language")&"_checkout_3")%></a></p>
<%end if%>
<p align="left"><%=dictLanguage.Item(Session("language")&"_checkout_4")%></p>
<form method="post" name="auth" action="comersus_customerAuthenticateExec.asp">
    <input type="hidden" name="redirectUrl" value="comersus_login.asp">
    <table width="500" border="0" align="left">
      
      <tr> 
        <td width="24%"><%=dictLanguage.Item(Session("language")&"_checkout_8")%></td>
        <td width="56%">           
          <%if pStoreFrontDemoMode="-1" then%>
            <input type="text" name="email" value="test@comersus.com">
          <%else%>
             <input type="text" name="email" value="">
          <%end if%>
        </td>       
        <td width="20%" rowspan="3">
         <%if pSecureStoreGraph="-1" then%> 
 	  <a href="http://www.comersus.com/secure.html" target="_blank"><img src="images/secureStore.gif" width="61" height="111" alt="Comersus Secure Store" border="0"></a> 
         <%end if%>
         </td>
      </tr>
      
      <tr> 
        <td width="24%"><%=dictLanguage.Item(Session("language")&"_checkout_9")%></td>
        <td width="56%">           
          <%if pStoreFrontDemoMode="-1" then%>
            <input type="password" name="password" value="123456">            
           <%else%>
            <input type="password" name="password" value="">
          <%end if%>          
          <%if pForgotPassword="-1" then%>
            <br><a href="comersus_optForgotPasswordForm.asp"><i><%=dictLanguage.Item(Session("language")&"_checkout_6")%></i></a>
          <%end if%>                    
        </td>         
      </tr>
      <tr> 
        <td width="24%"> 
          <input type="submit" name="Submit" value="<%=dictLanguage.Item(Session("language")&"_checkout_5")%>">
        </td>
        <td width="56%">&nbsp;</td>
        
      </tr>
    </table>
</form>  
<!--#include file="footer.asp"--> 
<%call closeDb()%>