<%
' Comersus 5.0x Sophisticated Cart 
' Developed by Rodrigo S. Alhadeff for Comersus Open Technologies
' United States 
' Open Source License can be found at License.txt
' http://www.comersus.com  

%>

<% 
' if it's a cancel request, go to cancel script
if request.form("Cancel")<>"" then
 response.redirect "comersus_checkOutCancelOrder.asp"
end if

%> 
<!--#include virtual="/comersus/includes/settings.asp"--> 
<!--#include virtual="/comersus/includes/getSettingKey.asp"--> 
<!--#include virtual="/comersus/includes/sessionFunctions.asp"--> 
<!--#include virtual="/comersus/includes/databaseFunctions.asp"--> 
<!--#include virtual="/comersus/includes/currencyFormat.asp"--> 
<!--#include virtual="/comersus/includes/languages.asp"--> 
<!--#include virtual="/comersus/includes/encryption.asp"--> 
<!--#include virtual="/comersus/includes/cartFunctions.asp"--> 
<!--#include virtual="/comersus/includes/dateFunctions.asp"--> 
<!--#include virtual="/comersus/includes/stringFunctions.asp"--> 
<!--#include virtual="/comersus/includes/miscFunctions.asp"--> 
<!--#include virtual="/comersus/includes/sendMail.asp"--> 
<!--#include virtual="/comersus/store/comersus_optDes.asp"-->    

<% 

on error resume next

dim mySQL, connTemp, rsTemp, pTotal, pTaxAmount, rsTemp3

' get settings 
pDefaultLanguage 		= getSettingKey("pDefaultLanguage")
pStoreFrontDemoMode 		= getSettingKey("pStoreFrontDemoMode")
pCurrencySign	 		= getSettingKey("pCurrencySign")
pDecimalSign	 		= getSettingKey("pDecimalSign")
pMoneyDontRound	 		= getSettingKey("pMoneyDontRound")
pCompany	 		= getSettingKey("pCompany")

pEmailSender			= getSettingKey("pEmailSender")
pEmailAdmin			= getSettingKey("pEmailAdmin")
pSmtpServer			= getSettingKey("pSmtpServer")
pEmailComponent			= getSettingKey("pEmailComponent")
pDebugEmail			= getSettingKey("pDebugEmail")
pRandomPassword			= getSettingKey("pRandomPassword")
pEncryptionPassword		= getSettingKey("pEncryptionPassword")
pFraudPreventionMode		= getSettingKey("pFraudPreventionMode")
pFraudPreventionSmallField	= getSettingKey("pFraudPreventionSmallField")
pFraudPreventionPriceField	= getSettingKey("pFraudPreventionPriceField")
pOrderPrefix			= getSettingKey("pOrderPrefix")
pUseEncryptedTotal		= getSettingKey("pUseEncryptedTotal")
pDisableSaveOrderEmail		= getSettingKey("pDisableSaveOrderEmail")
pDateFormat			= getSettingKey("pDateFormat")
pEncryptionMethod		= getSettingKey("pEncryptionMethod")

' get idDbSession in order to retrieve fields from the session
pIdDbSession			= getSessionVariable("idDbSession", 0)
pWishListIdCustomer		= getSessionVariable("wishListIdCustomer", 0)

if sessionLost() then response.redirect "comersus_message.asp?message="&Server.UrlEncode(dictLanguage.Item(Session("language")&"_saveorder_15"))

pIdDbSessionCart 	= checkDbSessionCartOpen()

' check if the cart is empty (user press SAVE twice)
if countCartRows(pIdDbSessionCart)=0 then response.redirect "comersus_message.asp?message="&Server.Urlencode(dictLanguage.Item(Session("language")&"_saveorder_16") )

pIdCustomer     	= getSessionVariable("idCustomer",0)
pIdCustomerType     	= getSessionVariable("idCustomerType",1)
pIdAffiliate     	= getSessionVariable("idAffiliate",1)

' get all fields from dbSession 

mySQL="SELECT sessionData FROM dbSession WHERE idDbSession=" &pIdDbSession
call getFromDatabase(mySQL, rstemp, "orderVerify")
 
if not rstemp.eof then
 
 pSessionData		=rstemp("sessionData") 
 pArraySessionData	=split(pSessionData,"||")
 
 pShipmentString 	= pArraySessionData(0)
 pDiscountCode 		= pArraySessionData(1)
 pComments 		= pArraySessionData(2)
 pUseBonusPoints 	= pArraySessionData(3)
 pIdPayment		= pArraySessionData(4)
 pVatNumber 		= pArraySessionData(5)
 pUser1 		= pArraySessionData(6)
 pUser2 		= pArraySessionData(7)
 pUser3 		= pArraySessionData(8)
 pIdPayment		= pArraySessionData(9)
 pPaymentDetails	= pArraySessionData(10)
 pBonusPoints		= pArraySessionData(11)
 pDiscountTotal		= pArraySessionData(12)
 pTaxAmount		= pArraySessionData(13)
 pTotal			= pArraySessionData(14)
 
end if

' get customer data

mySQL="SELECT * FROM customers WHERE idCustomer=" &pIdCustomer
call getFromDatabase(mySQL, rstemp, "saveOrder")

if not rstemp.eof then
 pName			= formatForDb(rstemp("name"))
 pLastName		= formatForDb(rstemp("lastName"))
 pCustomerCompany	= formatForDb(rstemp("customerCompany"))
 pEmail			= rstemp("email")
 pPassword		= rstemp("password")
 pPhone			= rstemp("phone") 

 pAddress		= formatForDb(rstemp("address"))
 pZip			= formatForDb(rstemp("zip"))
 pStateCode		= rstemp("stateCode")
 pState			= formatForDb(rstemp("state"))
 pCity			= formatForDb(rstemp("city"))
 pCountryCode		= rstemp("countryCode")

 pShippingAddress	= formatForDb(rstemp("shippingAddress"))
 pShippingZip		= formatForDb(rstemp("shippingZip"))
 pShippingStateCode	= rstemp("shippingStateCode")
 pShippingState		= formatForDb(rstemp("shippingState"))
 pShippingCity		= formatForDb(rstemp("shippingCity"))
 pShippingCountryCode   = rstemp("shippingCountryCode")
end if

' IP request to server variables
pBrowserIp		= request.ServerVariables("REMOTE_HOST")

' load for Offer Box display
session("customerName") = pName

' load optional Fraud Protection utility
%><!--#include file="comersus_optFraudPrevention.asp"--><%

' create date order var
pOrderDate=formatDate(Date())

' compile order details memo field (the field used for Download links, serials, etc)
mySQL="SELECT idCartRow, cartRows.idProduct, quantity, unitPrice, unitBtoBPrice, description, sku, deliveringTime, emailText, personalizationDesc FROM cartRows, products WHERE cartRows.idProduct=products.idProduct AND cartRows.idDbSessionCart="&pIdDbSessionCart    
  
call getFromDatabase(mySQL, rsTemp, "saveorder 4")    

  do while not rsTemp.eof
  
   pIdCartRow		= rsTemp("idCartRow")
   pIdProduct		= rsTemp("idProduct")
   pQuantity		= rsTemp("quantity")
   pUnitPrice		= Cdbl(rsTemp("unitPrice"))
   pUnitBtoBPrice	= Cdbl(rsTemp("unitBtoBPrice"))
   pDescription		= rsTemp("description")
   pSku			= rsTemp("sku")      
   pPersonalizationDesc	= rsTemp("personalizationDesc")      
   
   ' get optionals
   
    pOptionGroupsTotal=0
          
    ' get optionals for current cart row
  
    mySQL="SELECT optionDescrip, priceToAdd FROM cartRowsOptions WHERE idCartRow="&pIdCartRow	  	  	  	  
    
    call getFromDatabase(mySQL, rsTemp2, "saveorder 5")    
    
    pOptionsDescripCompound=""         
    
    do while not rsTemp2.eof
         
      pPriceToAdd			= Cdbl(rsTemp2("priceToAdd"))
      pOptionsDescripCompound		= pOptionsDescripCompound & rsTemp2("optionDescrip")&" "
  
      if pPriceToAdd>0 then
         pOptionsDescripCompound	= pOptionsDescripCompound &pCurrencySign & money(pPriceToAdd)
      end if	      
	  
      pOptionGroupsTotal	= pOptionGroupsTotal+ pPriceToAdd        
          
    rsTemp2.movenext
   loop                   
  
  if pIdCustomerType=1 then
     pRowPrice = Cdbl(pQuantity * (pOptionGroupsTotal+pUnitPrice) )         
   else
     pRowPrice = Cdbl(pQuantity * (pOptionGroupsTotal+pUnitBtoBPrice) )                  
   end if             
  
  ' compile order details `snapshot` (items are also saved into cartRows table)                
  pDetails	= pDetails & pQuantity& "x #" &pSku& "/" &pIdProduct & " " &pDescription 
  
  if pPersonalizationDesc<>"" then
    pDetails=pDetails&"(" &pPersonalizationDesc& ")"
  end if
  
  pDetails	= pDetails & " " &dictLanguage.Item(Session("language")&"_saveorder_12") &pOptionsDescripCompound& "= " &pCurrencySign & money(pRowPrice) &Vbcrlf              
  
  rsTemp.movenext
loop

if pBonusPoints>0 then 
 ' set discount details
 pDiscountDetails=dictLanguage.Item(Session("language")&"_orderverify_34") & " " & pCurrencySign&money(pBonusPoints) 
end if

' get shipment data
pShipmentDesc=""
shipmentTotal=0
call parseShipmentMethod(pShipmentString, pShipmentDesc, shipmentTotal)

pShipmentDetails = pShipmentDesc & " " &pCurrencySign & money(shipmentTotal)

' mark discount as used

if pDiscountCode<>"" then   

 pDiscountDetails = Cstr("")
 pDiscountDetails =dictLanguage.Item(Session("language")&"_orderverify_25") & " " & pDiscountCode &" " & pCurrencySign&money(pDiscountTotal) 
 
 mySQL="SELECT idDiscount, oneTime FROM discounts WHERE discountcode='" &pDiscountCode& "' AND active=-1 AND used=0"
 call getFromDatabase(mySQL, rsTemp3, "saveorder 7")    

 if not rsTemp3.eof then
   
    pIdDiscount				= rsTemp3("idDiscount")
    pOneTime				= rsTemp3("oneTime")    
    
    ' update discount used to true
    if pOneTime=-1 then         
     mySQL="UPDATE discounts SET used=-1 WHERE idDiscount="& pIdDiscount
     call updateDatabase(mySQL, rsTemp, "saveorder 7")        
    end if        
   
 end if ' discount not found

end if ' discount code active
  
' get selected payment

mySQL="SELECT paymentDesc, priceToAdd, percentageToAdd, redirectionUrl, emailText FROM payments WHERE idPayment=" &pIdPayment

call getFromDatabase(mySQL, rsTemp, "saveorder 7")    

if rsTemp.eof then response.redirect "comersus_supportError.asp?error="&Server.Urlencode("Cannot locate selected payments in database")

' load redirection and email text for payment method selected

pRedirectionUrl		= rsTemp("redirectionUrl")
pEmailText		= rsTemp("emailText")

pAffiliateValid =Cint(1)

if pIdAffiliate<>1 then
 ' check if idAffiliate is valid
 mySQL="SELECT idAffiliate FROM affiliates WHERE idAffiliate=" &pIdAffiliate

 call getFromDatabase(mySQL, rsTemp, "saveorder 8")    
 
 if rsTemp.eof then
  pAffiliateValid=0
 end If
 
end if ' affiliate valid

' if idAffiliate is not valid, set generic affiliate
if pAffiliateValid=0 then pIdAffiliate=1

' locate the id of the language used by the customer

if lCase(pDataBase) = "access" then
 mySQL="SELECT idLanguage FROM languages WHERE lCase(language)='" &session("language")&"'"	
else
 mySQL="SELECT idLanguage FROM languages WHERE lower(language)='" &session("language")&"'"
end if

call getFromDatabase(mySQL, rsTemp, "saveorder 8 1/2")    

if not rstemp.eof then
 pIdLanguage=rsTemp("idLanguage")
else
 pIdLanguage=1
end if

' generates a random number to locate inserted record without using specific DB methods 
pRandomNumber=randomNumber(99999)

' format fields for database
pTotalToSave		= replace(pTotal,",",".")
pTaxAmountToSave	= replace(pTaxAmount,",",".")
pDetails 		= formatForDb(pDetails)

' save order
mySQL="INSERT INTO orders (orderDate, idCustomer, details, total, taxAmount, obs, address, zip, state, stateCode, city, countryCode, shippingAddress, shippingZip, shippingState, shippingStateCode, shippingCity, shippingCountryCode, shipmentDetails, paymentDetails, discountDetails, nroRan, orderStatus, idAffiliate, viewed, idCustomerType, digitalEmailText, browserIp, vatNumber, idLanguage, wishListIdCustomer) VALUES ('" & pOrderDate  & "','" & Cstr(pIdCustomer)& "','" &pDetails &"'," &pTotalToSave& "," &pTaxAmountToSave& ",'" &pObs& "','" &pAddress & "','" &pZip& "','" &pState& "','" &pStateCode& "','" &pCity& "','" &pCountryCode& "','" &pShippingAddress & "','" &pShippingZip& "','" &pShippingState& "','" &pShippingStateCode& "','" &pShippingCity& "','" &pShippingCountryCode& "','" &pShipmentDetails& "','" &pPaymentDetails& "','" &pDiscountDetails& "'," &pRandomNumber& ",1," &pIdAffiliate& ",0," &pIdCustomerType& ",'" &pCompoundDiscountCodes& "','" &pBrowserIp& "','" &pVatNumber& "'," &pIdLanguage& "," &pWishListIdCustomer& ")"

call updateDatabase(mySQL, rsTemp, "saveorder 9")    

' get id of the saved order 
mySQL="SELECT idOrder FROM orders WHERE nroRan=" &pRandomNumber& " AND idCustomer=" &pIdCustomer

call getFromDatabase(mySQL, rsTemp, "saveorder 10")    

if  rsTemp.eof then response.redirect "comersus_supportError.asp?error="&Server.Urlencode("Error in saveorder 11. Couldnt locate generated order: "&pRandomNumber&", customer: "&pIdCustomer)

pIdorder=rsTemp("idOrder")

' save orderItems - assign idOrder to dbSessionCart and close the order

mySQL="UPDATE dbSessionCart SET idOrder=" &pIdOrder& ", cartOpen=0, idDbSession=NULL WHERE idDbSessionCart="&pIdDbSessionCart

call updateDatabase(mySQL, rsTemp, "saveorder 11")    

' delete dbSessionData inside dbSession
mySQL="UPDATE dbSession SET sessionData=NULL WHERE idDbSession="&pIdDbSession
    
call updateDatabase(mySQL, rsTemp, "saveorder 12")    

' rest bonus points used
if pBonusPoints>0 then
 pBonusPoints=replace(pBonusPoints,",",".") 
 mySQL="UPDATE customers SET bonusPoints=bonusPoints-" &pBonusPoints& " WHERE idCustomer="&pIdCustomer
 call updateDatabase(mySQL, rsTemp, "saveorder 13")       
end if

' compile email details text
customerEmail = Cstr("")
customerEmail = dictLanguage.Item(Session("language")&"_saveorder_1") &" "&pName&" "&pLastName&VBCrlf& dictLanguage.Item(Session("language")&"_saveorder_2") &VBCrlf&VBCrlf& dictLanguage.Item(Session("language")&"_saveorder_3") &VBCrlf&pDetails&VBCrlf&pPaymentDetails&VBCrlf&pShipmentDetails    

if pDiscountCode<>"" then
 customerEmail=customerEmail&VBCrlf&pDiscountDetails
end if

customerEmail=customerEmail&VBCrlf&dictLanguage.Item(Session("language")&"_saveorder_17")&pCurrencySign&money(pTaxAmount)&VBcrlf&"-------------------"&VBcrlf&dictLanguage.Item(Session("language")&"_saveorder_8") &" "&pCurrencySign& money(pTotal)&VBCrlf&VBCrlf

' send email notification to the store admin
call sendmail (pCompany, pEmailSender, pEmailAdmin, "New order in your store!, order: #"&pOrderPrefix&pIdorder, "Details: "&VBCrlf&pDetails&VBCrlf&"Customer: "&pName&" "&pLastName&VBcrlf&"Email: "&pemail&VBCrlf&"Address: "&pAddress&VBCrlf&"Phone #: "&pphone&VBcrlf&"Comments: "&pObs&VBCrlf&"Payment: "&pPaymentDetails&VBCrlf&"Shipping: "&pShipmentDetails&VBCrlf&"Discounts: "&pDiscountDetails&VBcrlf&"Taxes: "&pCurrencySign&money(pTaxAmount)&VBcrlf&"Order total: "&pCurrencySign&money(pTotal)&VBcrlf&VBcrlf& "Store powered by Comersus Sophisticated Cart"&VBcrlf&"http://www.comersus.com")

if trim(pEmailText)<>"" then customerEmail=customerEmail &VBcrlf&VBcrlf& dictLanguage.Item(Session("language")&"_saveorder_5") & pEmailText

call closeDb()

' clear header cart variables
session("cartSubTotal") = 0
session("cartItems")	= 0

if pUseEncryptedTotal="-1" then
   pGatewayTotal = EnCrypt(pTotal, pEncryptionPassword)
else
   pGatewayTotal = pTotal
end if

if pDisableSaveOrderEmail<>"-1"  then
 ' send default customer email (disable if you want the customer to receive an email when the payment has been authorised)
 call sendmail (pCompany, pEmailSender, pEmail, dictLanguage.Item(Session("language")&"_saveorder_6") &pCompany& ", "&  dictLanguage.Item(Session("language")&"_saveorder_7") &pOrderPrefix&pIdorder, customerEmail&VBCrlf&VBCrlf&pCompany&VBCrlf&pEmailAdmin&VBcrlf&VBcrlf &dictLanguage.Item(Session("language")&"_saveorder_13")& VBcrlf&VBcrlf& "Store powered by Comersus ASP e-commerce"&VBcrlf&"http://www.comersus.com")
end if

' go to a payment form or to default order confirmation
if trim(pRedirectionUrl)<>"" then
   response.redirect pRedirectionUrl&"?idOrder="&pOrderPrefix&pIdorder& "&OrderTotal=" &pGatewayTotal& "&name=" &Server.UrlEncode(pName)& "&lastName=" &Server.UrlEncode(pLastName)& "&address=" &Server.UrlEncode(pAddress)& "&city=" &Server.UrlEncode(pCity)& "&state=" &Server.UrlEncode(pState&pStateCode)& "&zip=" &Server.UrlEncode(pZip)& "&country=" &Server.UrlEncode(pCountryCode)& "&phone=" &Server.UrlEncode(pPhone)& "&email=" &Server.UrlEncode(pEmail) & "&orderDetails=" &Server.UrlEncode(pDetails)
else 
  ' redirect to default order confirmation
  response.redirect "comersus_defaultOrderConfirmation.asp?idOrder=" &pOrderPrefix&pIdOrder
end if


%>