<%
' Comersus 5.0x Sophisticated Cart 
' Developed by Rodrigo S. Alhadeff for Comersus Open Technologies
' United States 
' Open Source License can be found at License.txt
' http://www.comersus.com  
' Details: dynamic home: get products marked as showInHome
%>

<!--#include virtual="/comersus/includes/settings.asp"--> 
<!--#include virtual="/comersus/includes/getSettingKey.asp"--> 
<!--#include virtual="/comersus/includes/sessionFunctions.asp"--> 
<!--#include virtual="/comersus/includes/languages.asp"-->
<!--#include virtual="/comersus/includes/databaseFunctions.asp"--> 
<!--#include virtual="/comersus/includes/currencyFormat.asp"--> 
<!--#include virtual="/comersus/includes/switchLanguage.asp"--> 
<!--#include virtual="/comersus/includes/specialPrice.asp"--> 
<!--#include virtual="/comersus/includes/miscFunctions.asp"--> 

<% 

on error resume next 

dim connTemp, rsTemp, rsTemp3, pRowsShown, pMaxPopularity, arrCounter, pIdCustomer, pIdCustomerType, howManyHome, mySQL, pDefaultLanguage, pStoreFrontDemoMode, pCurrencySign, pDecimalSign, pMoneyDontRound, pCompany, pCompanyLogo, pHeaderKeywords, pAuctions, pListBestSellers, pNewsLetter, pPriceList, pStoreNews, pOneStepCheckout, pAffiliatesStoreFront, pShowStockView, pIdProductVip, pLastChanceListing, pAllowNewCustomer, pListProductsByLetter, pRunInstallationWizard, pIdProduct, pDescription, pDetails, pDetailsVip, pImageUrlVip, pLanguage, pCustomerName, pHeaderCartItems, pHeaderCartSubtotal, pItemCounter, f, h

' get settings 
pDefaultLanguage 	= getSettingKey("pDefaultLanguage")
pStoreFrontDemoMode 	= getSettingKey("pStoreFrontDemoMode")
pCurrencySign	 	= getSettingKey("pCurrencySign")
pDecimalSign	 	= getSettingKey("pDecimalSign")
pMoneyDontRound	 	= getSettingKey("pMoneyDontRound")

pCompany	 	= getSettingKey("pCompany")
pCompanyLogo	 	= getSettingKey("pCompanyLogo")
pHeaderKeywords		= getSettingKey("pHeaderKeywords")

pAuctions		= getSettingKey("pAuctions")
pListBestSellers 	= getSettingKey("pListBestSellers")
pNewsLetter 		= getSettingKey("pNewsLetter")
pPriceList 		= getSettingKey("pPriceList")
pStoreNews 		= getSettingKey("pStoreNews")
pOneStepCheckout	= getSettingKey("pOneStepCheckout")
pAffiliatesStoreFront   = getSettingKey("pAffiliatesStoreFront")
pShowStockView		= getSettingKey("pShowStockView")
pIdProductVip		= getSettingKey("pIdProductVip")
pLastChanceListing	= getSettingKey("pLastChanceListing")
pAllowNewCustomer	= getSettingKey("pAllowNewCustomer")
pListProductsByLetter	= getSettingKey("pListProductsByLetter")
pRunInstallationWizard 	= getSettingKey("pRunInstallationWizard")


if pRunInstallationWizard="-1" then response.redirect "../backofficeLite/comersus_backoffice_install0.asp"

' defines how many rows it will show in the home (consider that if there are no enough products you will get empty cells)
pRowsShown 		= getSettingKey("pRowsShown")

pMaxPopularity 	= 0
arrCounter	= 0
pIdCustomer     = getSessionVariable("idCustomer",0)
pIdCustomerType = getSessionVariable("idCustomerType",1)

' get how many products are marked as showInHome

mySQL="SELECT COUNT(idProduct) as howManyHome FROM products WHERE showInHome=-1 AND active=-1"

call getFromDatabase (mySql, rsTemp3, "dynamic_index")

if rsTemp3.eof then
 howManyHome=0
else
 howManyHome=rstemp3("howManyHome")
end if

if Cint(howManyHome)<Cint(pRowsShown*2) then 
 ' redirect to categories listing since there are no enough products to show in home
 response.redirect "comersus_listCategoriesAndProducts.asp"
end if

' get products marked as showInHome

mySQL="SELECT idProduct, description, details, price, imageUrl, stock, bToBPrice, visits FROM products WHERE showInHome=-1 AND active=-1"

call getFromDatabase (mySql, rsTemp3, "dynamic_index")

if rsTemp3.eof then
 response.redirect "comersus_message.asp?message="&Server.Urlencode(dictLanguage.Item(Session("language")&"_dynamicindex_1") )
end if

' define the array to store products (2 columns)
reDim arrProducts(pRowsShown*2,8)

' load the array only with spots available 

do while (not rstemp3.eof) and arrCounter<(pRowsShown*2)  
 pIdProduct 	= rstemp3("idProduct")
 pDescription	= rstemp3("description")
 pDetails 	= rstemp3("details")
 
 ' switch description and details depending on user selected language
 switchProductsLanguage session("language"), pIdProduct, pDetails, pDescription
 
 ' load product array 
 arrProducts(arrCounter,0)= pIdProduct
 arrProducts(arrCounter,1)= pDescription 
 ' cut description only if it has no HTML tags insidem, check with BR tag only
 if instr(arrProducts(arrCounter,2),"<BR>")=0 then arrProducts(arrCounter,2)= left(pDetails,180)&"..."
 arrProducts(arrCounter,3)= rstemp3("price")
 arrProducts(arrCounter,4)= rstemp3("imageUrl")
 arrProducts(arrCounter,5)= rstemp3("stock")
 arrProducts(arrCounter,6)= rstemp3("bToBprice")
 arrProducts(arrCounter,7)= rstemp3("visits")
 
 arrCounter = arrCounter+1
 
 rstemp3.moveNext
loop 

pMaxPopularity=getMax(arrProducts)

' get 1 to 5 main categories (root)

mySQL="SELECT idCategory, categoryDesc FROM categories WHERE idParentCategory=1 AND active=-1 AND idCategory<>1 ORDER BY categoryDesc"

call getFromDatabase (mySql, rsTemp, "dynamic_index")

' define the array to store categories
reDim arrCategories(5,2)
arrCounter=0

do while not rstemp.eof and arrCounter<5
 arrCategories(arrCounter,0)=rstemp("idCategory")
 arrCategories(arrCounter,1)=rstemp("categoryDesc")
 arrCounter=arrCounter+1
 rstemp.movenext
loop

' get VIP details

if pIdProductVip<>"" then
 mySQL="SELECT details, imageUrl FROM products WHERE active=-1 AND idProduct="&pIdProductVip

 call getFromDatabase (mySql, rsTemp3, "dynamic_index")

 if rsTemp3.eof then
  pIdProductVip=""
 else 
   pDetailsVip	=rstemp3("details") 
   pImageUrlVip	=rstemp3("imageUrl")  
   ' switch description and details depending on user selected language
   switchProductsLanguage session("language"), pIdProductVip, pDetailsVip, "-"
  end if
 
end if

%>
<!--#include file="header.asp"-->      
<br>
      <table border=0 cellpadding=0 cellspacing=0 width="100%">
      <tr>
          <td colspan=5>
            <table width="812" border="0" cellspacing="0" cellpadding="0">
             
             <%if pIdProductVip<>"" then%>
              <tr>
                <td width="129">
                <%if pImageUrlVip<>"" then%> 
                  <a href="comersus_viewItem.asp?idProduct=<%=pIdProductVip%>"><img align=left border=0 src="catalog/<%=pImageUrlVip%>" vspace=3></a> 
                <%else%> 
                   <img src='catalog/imageNA.gif' alt="Image not available"> 
                <%end if%>
                </td>
                <td width="683">
                <%=pDetailsVip%>
                <br><a href="comersus_viewItem.asp?idProduct=<%=pIdProductVip%>"><%=dictLanguage.Item(Session("language")&"_dynamicindex_2")%></a>
                </td>
              </tr>
              <%end if%>
              
            </table>
          </td>
        </tr>                        
        <%
pItemCounter=0
for f=0 to pRowsShown-1
%> 
        <tr> 
    <td valign=top width="499"></td>
    <!-- Column spacers begin --> 
    <td width=7> <img border=0 height=1 src="images/cleardot.gif" width=5></td>
    <td width=1> <img border=0 height=1 src="images/cleardot.gif" width=1></td>
    <td width=13><img border=0 height=1 src="images/cleardot.gif" width=9></td>
    <!-- Column spacers end --> 
    <td width="467"></td>
  </tr>
  <tr> 
    <td colspan=5> <img border=0 height=5 src="images/cleardot.gif" width=1><br>
      <img border=0 height=1 src="images/ruledot.gif" width="100%" vspace=5><br>
    </td>
  </tr>
  <tr valign=top> 
    <td width="499"> <img border=0 height=8 src="images/cleardot.gif" width=2><br>
                
     <%if arrProducts(pItemCounter,4)<>"" then%>
      <br><a href="comersus_viewItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><img align=left alt="<%=arrProducts(pItemCounter,1)%>" border=0 src="catalog/<%=arrProducts(pItemCounter,4)%>" vspace=3></a> 
     <%else%>
       <img src='catalog/imageNA.gif' alt="Image not available">              
     <%end if%>
            
     <b><%=arrProducts(pItemCounter,1)%></b>
     <br><br><%=arrProducts(pItemCounter,2)%>     
     <br><a href="comersus_viewItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><%=dictLanguage.Item(Session("language")&"_dynamicindex_2")%></a>
     <br clear=left><img border=0 height=4 hspace=0 src="images/cleardot.gif" width=3>               
     <br>
     <%if pIdCustomerType=1 or arrProducts(pItemCounter,6)=0 then%>
      <%=dictLanguage.Item(Session("language")&"_dynamicindex_3") &pCurrencySign & money(arrProducts(pItemCounter,3))%> 
     <%else%>
      <%=dictLanguage.Item(Session("language")&"_dynamicindex_3") &pCurrencySign & money(arrProducts(pItemCounter,6))%> 
     <%end if%>
     <%if pShowStockView="-1" then%>
      <i>(<%=dictLanguage.Item(Session("language")&"_dynamicindex_9")%>: <%=arrProducts(pItemCounter,5)%>)</i>
     <%end if%>
     
     <br><%=dictLanguage.Item(Session("language")&"_dynamicindex_11")%> <%=arrProducts(pItemCounter,7)%> <img border=0 src="images/<%=getPopularity(arrProducts(pItemCounter,7),pMaxPopularity)%>popular.gif"> 
     <br><br><a href="comersus_addItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><img src="images/<%=pLanguage%>/small_addCart.gif" border="0"></a>
     <%pItemCounter=pItemCounter+1%>     
      
       <!-- DO NOT REMOVE -- SPACER GIF FOR BOXES --><br>
      <img border=0 height=1  src="images/cleardot.gif" width=250 hspace=0><br>
      <img border=0 height=10 src="images/cleardot.gif" width=170> </td>
    <%' column %> 
    <td width=7> <img border=0 height=1      src="images/cleardot.gif" width=5></td>
    <td width=1 bgcolor=#cccc99><img border=0 height="100%" src="images/ruledot.gif" width=1></td>
    <td width=13> <img border=0 height=1      src="images/cleardot.gif" width=9></td>
    <%' Cell 2 %> 
    <td width="467"> <img border=0 height=10 src="images/cleardot.gif" width=205><br>
     
     <%if arrProducts(pItemCounter,4)<>"" then%>
       <br><a href="comersus_viewItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><img align=left alt="<%=arrProducts(pItemCounter,1)%>" border=0 src="catalog/<%=arrProducts(pItemCounter,4)%>" vspace=3></a> 
     <%else%>
       <img src='catalog/imageNA.gif' alt="Image not available">              
     <%end if%>          
     
     <b><%=arrProducts(pItemCounter,1)%></b>
     <br><br><%=arrProducts(pItemCounter,2)%>     
     <br><a href="comersus_viewItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><%=dictLanguage.Item(Session("language")&"_dynamicindex_2")%></a>
     <br clear=left><img border=0 height=4 hspace=0 src="images/cleardot.gif" width=3>               
     <br>
     
     <%if pIdCustomerType=1 or arrProducts(pItemCounter,6)=0 then%>
      <%=dictLanguage.Item(Session("language")&"_dynamicindex_3") &pCurrencySign & money(arrProducts(pItemCounter,3))%> 
     <%else%>
      <%=dictLanguage.Item(Session("language")&"_dynamicindex_3") &pCurrencySign & money(arrProducts(pItemCounter,6))%> 
     <%end if%>
     
     <%if pShowStockView="-1" then%>
      <i>(<%=dictLanguage.Item(Session("language")&"_dynamicindex_9")%>: <%=arrProducts(pItemCounter,5)%>)</i>
     <%end if%>
     
     <br><%=dictLanguage.Item(Session("language")&"_dynamicindex_11")%> <%=arrProducts(pItemCounter,7)%> <img border=0 src="images/<%=getPopularity(arrProducts(pItemCounter,7),pMaxPopularity)%>popular.gif"> 
     <br><br><a href="comersus_addItem.asp?idProduct=<%=arrProducts(pItemCounter,0)%>"><img src="images/<%=pLanguage%>/small_addCart.gif" border="0"></a>
     <%pItemCounter=pItemCounter+1%>      
     
      <!-- DO NOT REMOVE -- SPACER GIF FOR BOXES --><br>
      <img border=0 height=1  src="images/cleardot.gif" width=250 hspace=0 ><br>
      <img border=0 height=10 src="images/cleardot.gif" width=170> </td>
  </tr>
  <%next%>        
    <tr> 
    <td colspan=5>
      <img border=0 height=5  src="images/cleardot.gif" width=1><br>
      <img border=0 height=1  src="images/ruledot.gif" vspace=5 width="100%"><br>
      <%' featured categories%>
     <br><b><%=dictLanguage.Item(Session("language")&"_dynamicindex_10")%></b>: 
     <%
     ' only shows 5 categories
     if arrCounter>4 then arrCounter=4
     for h=0 to arrCounter-1%>
     <%=h+1%>. <a href="comersus_listCategoriesAndProducts.asp?idCategory=<%=arrCategories(h,0)%>"><%=arrCategories(h,1)%></a> 
     <%if h<3 then%>
     | 
     <%end if%>
     <%next%>
                
     <!--#include file="comersus_optBringRandomProduct.asp"-->             
       
     <br><img src="images/nav_buzz.gif" width="135" height="20">
                
        <%if pAuctions="-1" then%>
          <a href="comersus_optAuctionListAll.asp?redirectUrl=comersus_optauctionlistall.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_4")%></a>  (new!) |
        <%end if%>
        
         <a href="comersus_listSuppliers.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_5")%></a> 
       | <a href="comersus_listHotDealsProducts.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_6")%></a>  
              
       <%if pListBestSellers="-1" then%>
         | <a href="comersus_optListBestSellers.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_7")%></a>
       <%end if%>
       
       <%if pLastChanceListing="-1" then%>              
         | <a href="comersus_optLastChanceListing.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_12")%></a>
       <%end if%>   
       
       <%if pListProductsByLetter="-1" then%>              
         | <a href="comersus_optSearchByLetterForm.asp"><%=dictLanguage.Item(Session("language")&"_dynamicindex_13")%></a>
       <%end if%>   
       
    </td>
  </tr>
  <tr> 
    <td colspan=5 height="13">
      <img border=0 height=5 src="images/cleardot.gif" width=1><br>
      <img border=0 height=1 src="images/ruledot.gif" vspace=5 width="100%"><br>
    </td>
  </tr>  
  <tr> 
    <td height=20 width="499"></td>
  </tr>
 </table>
<!--#include file="footer.asp"--> 
<%call closeDb()%>

